/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using Battlehub.RTCommon;using MeshVR;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using System;using UnityEngine.EventSystems;using UnityEngine.UI;namespace PluginIdea.ContexMenuSystem{public class ContexMenuSystem : MVRScript, IGL{public const string CoreModule = "CoreModule";public const string SettingModule = "SettingModule";public const string VisualizeModule = "VisualizeModule";public const string InputModule = "InputModule";public const string VAMEventModule = "VAMEventModule";public const string UndoRedoMoudule = "UndoRedoMoudule";public JSONStorableAction.ActionCallback systemMenuAction;public JSONStorableAction.ActionCallback sceneCommonMenuAction;private CameraHook cameraHook;private Request request;private bool isResourcesLoaded;private Dictionary<string, CMModuleBase> uid2Modules = new Dictionary<string, CMModuleBase>();private Dictionary<string, Shader> dic_name2Shader = new Dictionary<string, Shader>();private List<RaycastResult> castList = new List<RaycastResult>();private RaycastHit raycastHit;private RaycastHit[] tmpRaycastHits = new RaycastHit[5];private EventBus eventBus;private bool isEnable = true;public static Atom containerAtom;public Transform RightHandTrans{get{if (SuperController.singleton.isOpenVR){return SuperController.singleton.viveObjectRight;}return SuperController.singleton.touchObjectRight;}}public Transform LeftHandTrans{get{if (SuperController.singleton.isOpenVR){return SuperController.singleton.viveObjectLeft;}return SuperController.singleton.touchObjectLeft;}}public bool ShouldDisActive{get{return !isEnable || (GlobalSetting.disableOnPlayMode && SuperController.singleton.gameMode == SuperController.GameMode.Play);}}public RaycastHit RaycastHit{get{return raycastHit;}}public List<RaycastResult> CastList{get{return castList;}}public static bool IsHitSomthing{get{return isUICast || isHitObject;}}public Dictionary<string, Shader> Dic_name2Shader{get{return dic_name2Shader;}}private Canvas popCanvas;public Canvas PopCanvas{get{return popCanvas;}set{popCanvas = value;}}private Transform tipTrans;public Transform TipTrans{get{return tipTrans;}}private Text tipLabel;public Text TipLabel{get{return tipLabel;}set{tipLabel = value;}}private GameObject contextMenuObject;public GameObject ContexMenuUIObject{get{return contextMenuObject;}}private GameObject subMenuObject;public GameObject SubMenuObject{get{return subMenuObject;}}public bool IsResourceLoaded{get{return this.isResourcesLoaded;}}public override void Init(){base.Init();DataInit();UIInit();EventInit();}private Button hardResetBtn;private void RegistBundleUnload(){hardResetBtn = SuperController.singleton.mainHUD.Find("MainUICanvas/Panel/Content/TabFile/Content/Hard Reset Button").GetComponent<Button>();hardResetBtn.onClick.AddListener(UnloadBundle);}private void UnloadBundle(){if (request != null && request.assetBundle != null){Debug.Log("Unload ---------------------");request.assetBundle.Unload(false);}}private void Start(){if (Utils.IsInVR()){cameraHook = Utils.GetSafeComponent<CameraHook>(Utils.CenterCameraTrans.gameObject);cameraHook.onPostRenderCallback += OnPostRender;}else{if (GLRenderer.Instance == null){new GameObject{name = "GLRenderer"}.AddComponent<GLRenderer>();}GLRenderer.Instance.Add(this);}}private void DataInit(){containerAtom = containingAtom;string assetsBundlePath = Utils.GetPluginPath(this) + string.Format("/resources/contexmenu{0}.assetbundle", Utils.version);request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private void OnAssetBundleLoaded(Request abffr){var subMenuAs = abffr.assetBundle.LoadAsset<GameObject>("Menu Item");subMenuObject = Instantiate<GameObject>(subMenuAs);var subMenuMono = Utils.GetSafeComponent< ContextMenuItem>(subMenuObject);subMenuMono.textLabel = subMenuObject.transform.Find("Text").GetComponent<Text>();subMenuMono.textLabel.resizeTextForBestFit = !Utils.IsInVR();subMenuMono.subMenuArrow = subMenuObject.transform.Find("Sub Menu Arrow").GetComponent<Text>();Button.ButtonClickedEvent onClick = subMenuMono.GetComponent<Button>().onClick;onClick.RemoveAllListeners();onClick.AddListener(subMenuMono.OnClick);var contexMenuAs = abffr.assetBundle.LoadAsset<GameObject>("Context Menu");contextMenuObject = Instantiate<GameObject>(contexMenuAs);contextMenuObject.SetActive(false);var contexMenuMono = Utils.GetSafeComponent<ContextMenu>(contextMenuObject);contexMenuMono.selector = contextMenuObject.transform.Find("Selector").gameObject;contexMenuMono.menuLayout = contexMenuMono.transform.Find("Menu").GetComponent<VerticalLayoutGroup>();contexMenuMono.menuItemPrefab = subMenuObject.GetComponent<ContextMenuItem>();var tipAs = abffr.assetBundle.LoadAsset<GameObject>("TipText");GameObject tipObj = Instantiate<GameObject>(tipAs);tipObj.SetActive(false);tipObj.transform.SetParent(popCanvas.transform);tipObj.transform.localRotation = Quaternion.identity;tipTrans = tipObj.transform;tipLabel = Utils.GetSafeComponent<Text>(tipObj.transform.Find("label").gameObject);if (popCanvas != null){contexMenuMono.canvas = popCanvas;}var shaders = abffr.assetBundle.LoadAllAssets<Shader>();if (shaders.Length > 0){for (int i = 0;i < shaders.Length;i++){if (!dic_name2Shader.ContainsKey(shaders[i].name)) dic_name2Shader.Add(shaders[i].name, shaders[i]);}}isResourcesLoaded = true;ReApplyUIParameter();}private void UIInit(){Utils.OnInitUI(CreateUIElement);}static bool isUICast;static bool isHitObject;private void Update(){if (Input.GetKeyDown(KeyCode.F6))                SetEnable();if (ShouldDisActive) return;foreach (var module in uid2Modules.Values.ToList()){module.OnUpdate();}}private void FixedUpdate(){if (ShouldDisActive) return;foreach (var module in uid2Modules.Values.ToList()){module.OnFixedUpdate();}}private void LateUpdate(){if (ShouldDisActive) return;foreach (var module in uid2Modules.Values.ToList()){module.OnLateUpdate();}}private void EventInit(){eventBus = EventBus.Instance;RegisterModule(CoreModule, new CoreModule(this));RegisterModule(SettingModule, new SettingModule(this));RegisterModule(VisualizeModule, new VisualizeModule(this));RegisterModule(InputModule, new InputModule(this));RegisterModule(VAMEventModule, new VAMEventModule(this));RegisterModule(UndoRedoMoudule, new UndoRedoMoudule(this));SuperController.singleton.BroadcastMessage("OnActionsProviderAvailable", this, SendMessageOptions.DontRequireReceiver);}private void RegisterModule(string key, CMModuleBase module){if (!uid2Modules.ContainsKey(key)){uid2Modules.Add(key, module);module.Init();}}private void UnRegisterModule(string key){if (uid2Modules.ContainsKey(key)){uid2Modules[key].UnInit();uid2Modules.Remove(key);}}public bool isPaidVersion = false;private void ReApplyUIParameter(){if (uid2Modules.Count > 0){foreach (var module in uid2Modules.Values.ToList()){module.OnReApplyUIParameter();}}}public void OnBindingsListRequested(List<object> bindings){bindings.Add(new JSONStorableAction("SystemMenu", systemMenuAction));bindings.Add(new JSONStorableAction("SceneMenu", sceneCommonMenuAction));bindings.Add(new JSONStorableAction("Enable/DisEnable", SetEnable));bindings.Add(new JSONStorableAction("Show Surrounding Box", SetIsShowSurroudingBox));}private void SetIsShowSurroudingBox(){GlobalSetting.showOutLine = !GlobalSetting.showOutLine;}private void SetEnable(){isEnable = !isEnable;}private void OnDestroy(){if (hardResetBtn != null){hardResetBtn.onClick.RemoveListener(UnloadBundle);}if (uid2Modules.Count > 0){foreach (var key in uid2Modules.Keys.ToList()){UnRegisterModule(key);}uid2Modules.Clear();}if (Utils.IsInVR()){Destroy(cameraHook);}else{GLRenderer.Instance.Remove(this);}Utils.OnDestroyUI();SuperController.singleton.BroadcastMessage("OnActionsProviderDestroyed", this, SendMessageOptions.DontRequireReceiver);Destroy(subMenuObject);Destroy(contextMenuObject);Destroy(eventBus.gameObject);}public GraphicRaycaster RaycastInCanvas;public bool GetUIRaycastList(){if (!EventSystem.current.IsPointerOverGameObject()) return false;var selectedAtom = SuperController.singleton.GetSelectedAtom();if (selectedAtom != null){RaycastInCanvas = selectedAtom.GetComponentInChildren<GraphicRaycaster>();if (RaycastInCanvas != null){castList.Clear();CheckGuiRaycastObjects(castList);if (castList.Count > 0) return true;}}else{var cur = EventSystem.current.currentSelectedGameObject;if (cur != null){RaycastInCanvas = cur.GetComponentInParent<GraphicRaycaster>();if (RaycastInCanvas != null){castList.Clear();CheckGuiRaycastObjects(castList);if (castList.Count > 0) return true;}}}return false;}private void CheckGuiRaycastObjects(List<RaycastResult> list){PointerEventData eventData = new PointerEventData(EventSystem.current);eventData.pressPosition = Input.mousePosition;eventData.position = Input.mousePosition;RaycastInCanvas.Raycast(eventData, list);}public bool IsCastObject(){Ray ray = GetCastRay();isHitObject = Physics.Raycast(ray, out raycastHit, GlobalSetting.rayCheckDistance);return isHitObject;}public bool GetRaycastObject(){Ray ray = GetCastRay();tmpRaycastHits = new RaycastHit[5];int hitCount = Physics.RaycastNonAlloc(ray, tmpRaycastHits, GlobalSetting.rayCheckDistance);if (hitCount > 0){for (int i = 0;i < tmpRaycastHits.Length;i++){if (tmpRaycastHits[i].collider != null){bool isController = tmpRaycastHits[i].collider.GetComponent<FreeControllerV3>() != null;if (isController){raycastHit = tmpRaycastHits[i];return true;}}}}return Physics.Raycast(ray, out raycastHit, GlobalSetting.rayCheckDistance);}private Ray GetCastRay(){Ray ray = new Ray();if (Utils.IsInVR()){if (GlobalSetting.currentOptMode == OperationMode.DoubleHandle || GlobalSetting.currentOptMode == OperationMode.SingleHandleRight){ray = new Ray(RightHandTrans.position, RightHandTrans.forward);}else{ray = new Ray(LeftHandTrans.position, LeftHandTrans.forward);}}else{ray = SuperController.singleton.MonitorCenterCamera.ScreenPointToRay(Input.mousePosition);}return ray;}private void OnPostRender(){if (ShouldDisActive) return;foreach (var module in uid2Modules.Values.ToList()){module.OnPostRender();}}public void Draw(int cullingMask){OnPostRender();}}}