/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using UnityEngine.UI;using System.Collections.Generic;using UnityEngine.EventSystems;using System;namespace PluginIdea.ContexMenuSystem{public class ContextMenu : MonoBehaviour, IPointerExitHandler{public static Vector3 startingClickPosition;public Canvas canvas;public VerticalLayoutGroup menuLayout;public GameObject selector;public ContextMenuItem menuItemPrefab;[HideInInspector]        public ContextMenu parentMenu;[HideInInspector]        public List<ContextMenuItem> menuItems = new List<ContextMenuItem>();public const float HoverTimer = 0f;void Start(){if (Utils.IsInVR()){EventBus.Instance.AddEventHandler(EventID.OnLeftSelectUpEvent, OnSelectClick);EventBus.Instance.AddEventHandler(EventID.OnRightSelectUpEvent, OnSelectClick);}}private void OnSelectClick(){SuperController.singleton.StartCoroutine(DelayHide());}void Update(){if(!Utils.IsInVR()){if (Input.GetMouseButtonDown(0))                    SuperController.singleton.StartCoroutine(DelayHide());}}private IEnumerator DelayHide(){yield return new WaitForSeconds(.2f);Hide();}public static void HideAllMenus(){ContextMenu[] openMenus = FindObjectsOfType<ContextMenu>();for (int i = 0;i < openMenus.Length;i++)                openMenus[i].Hide();}public void ShowInVR(){gameObject.SetActive(true);SuperController.singleton.StartCoroutine(HideFix());}private IEnumerator HideFix(){yield return new WaitForSeconds(0.1f);gameObject.SetActive(true);}public void ShowAtMousePosition(){gameObject.SetActive(true);RectTransform transform = ((RectTransform)base.transform);startingClickPosition = Input.mousePosition;if (canvas.renderMode == RenderMode.ScreenSpaceOverlay)                transform.position = startingClickPosition;else                transform.position = ConvertMouseToGUISpace(canvas);if (startingClickPosition.y > Screen.height * 0.5f)                transform.anchoredPosition -= new Vector2(0, transform.sizeDelta.y);if (startingClickPosition.x > Screen.width * 0.7f)                transform.anchoredPosition -= new Vector2(transform.sizeDelta.x, 0);}public Vector3 GetOffset(){if (menuItems.Count > 0){var endItem = menuItems[menuItems.Count - 1];float ry = GetComponent<RectTransform>().rect.height;Vector3 epos = endItem.transform.position;if (epos.y < 0){return new Vector3(0, -epos.y, 0);}else if (epos.y > Screen.height - ry){return new Vector3(0, -(epos.y - (Screen.height - ry)), 0);}}return Vector3.zero;}public void Hide(){gameObject.SetActive(false);selector.SetActive(false);for (int i = 0;i < menuItems.Count;i++)                if (menuItems[i].subMenu != null){menuItems[i].StopAllCoroutines();menuItems[i].keepMenuOpen = false;menuItems[i].subMenu.Hide();}}public void AddMenuItem(string description, ContextMenuItem.StandardDelegate onClickMethod, int fontSize = 55, bool isSplit = false){AddMenuItem(description, onClickMethod, null, fontSize, isSplit);}public void AddMenuItem(string description, ContextMenuItem.StandardDelegate onClickMethod, ContextMenu subMenu, int fontSize, bool isSplit){ContextMenuItem temp = Instantiate<GameObject>(menuItemPrefab.gameObject).GetComponent<ContextMenuItem>();temp.transform.SetParent(menuLayout.transform);temp.transform.localScale = Vector3.one;temp.transform.localPosition = Vector3.zero;temp.transform.localRotation = Quaternion.identity;temp.Initialise(this, description, onClickMethod, subMenu, fontSize);menuItems.Add(temp);if (isSplit) AddSplitBar();}private void AddSplitBar(){Transform barTrans = new GameObject("Bar").transform;barTrans.SetParent(menuLayout.transform);barTrans.localPosition = Vector3.zero;barTrans.localRotation = Quaternion.identity;barTrans.localScale = Vector3.one;var cv = barTrans.gameObject.AddComponent<CanvasRenderer>();var image = cv.gameObject.AddComponent<Image>();image.color = Color.gray;var layout = cv.gameObject.AddComponent<LayoutElement>();layout.minHeight = 1;layout.preferredWidth = 190;}public void FinaliseMenu(){((RectTransform)transform).sizeDelta = new Vector2(((RectTransform)transform).sizeDelta.x, menuItems.Count * ((RectTransform)selector.transform).sizeDelta.y + menuLayout.padding.top + menuLayout.padding.bottom);}public void SupressHiding(){for (int i = 0;i < menuItems.Count;i++)                menuItems[i].keepMenuOpen = true;selector.SetActive(true);}public void OnPointerExit(PointerEventData eventData){selector.SetActive(false);}private void OnDestroy(){if (Utils.IsInVR()){EventBus.Instance.RemoveEventHandler(EventID.OnLeftSelectUpEvent, OnSelectClick);EventBus.Instance.RemoveEventHandler(EventID.OnRightSelectUpEvent, OnSelectClick);}}public void CloseOtherSubMenus(ContextMenuItem caller){for (int i = 0;i < menuItems.Count;i++)                if (menuItems[i].subMenu != null)                    if (!caller.Equals(menuItems[i]))                        menuItems[i].subMenu.Hide();}public static RectTransform GetHighestMenu(ContextMenu menu){while (menu.parentMenu != null)                menu = menu.parentMenu;return menu.transform as RectTransform;}static Vector3 ConvertMouseToGUISpace(Canvas canvas){Vector2 position;RectTransformUtility.ScreenPointToLocalPointInRectangle(canvas.transform as RectTransform, Input.mousePosition, canvas.worldCamera, out position);return canvas.transform.TransformPoint(position);}}}