/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using SimpleJSON;using MVR.FileManagementSecure;using System.Collections.Generic;using System;using System.Linq;namespace PluginIdea.ContexMenuSystem{public class PluginAddCommand{public Dictionary<string, PluginManifestEntry> pluginManinfestDict = new Dictionary<string, PluginManifestEntry>();public PluginAddCommand(){this.Init();EventBus.Instance.AddEventHandler(EventID.OnRefreshPluginDataEvent, RefreshItems);}public void Init(){RefreshItems();}public void UnInit(){EventBus.Instance.RemoveEventHandler(EventID.OnRefreshPluginDataEvent, RefreshItems);pluginManinfestDict.Clear();}public void RefreshItems(){HashSet<string> varFiles = Utils.GetFilesAtPathRecursive("AddonPackages", "*.var");foreach (string varFile in varFiles){ProcessNewVARFile(varFile);}}private void ProcessNewVARFile(string varFilePath){if (FileManagerSecure.FileExists(varFilePath + ":\\meta.json")){try{JSONClass varMetaFile = (JSONClass)SuperController.singleton.LoadJSON(varFilePath + ":\\meta.json");JSONArray contentList = null;if (varMetaFile != null && varMetaFile["contentList"] != null) contentList = varMetaFile["contentList"].AsArray;else{Debug.Log("<ProcessNewVARFile>: Possible malformed meta.json file in VAR '" + varFilePath + "'");return;}HashSet<string> csFiles = new HashSet<string>();HashSet<string> csListFiles = new HashSet<string>();foreach (JSONNode node in contentList){string fileName = null;try{fileName = FileManagerSecure.NormalizePath(node);}catch (Exception e){Debug.Log("<ProcessNewVARFile> meta.json for VAR '" + varFilePath + "' contains possible malformed contents list");}if (fileName != null && fileName.StartsWith("Custom/Scripts")){if (fileName.EndsWith(".cs") || fileName.EndsWith(".dll")) csFiles.Add(fileName);else if (fileName.EndsWith(".cslist")) csListFiles.Add(fileName);else if (FileManagerSecure.IsDirectoryInPackage(varFilePath + ":\\" + fileName)){HashSet<string> orphanCsFiles = Utils.GetFilesAtPathRecursive(varFilePath + ":\\" + fileName, "*.cs", true);csFiles.UnionWith(orphanCsFiles);HashSet<string> orphanDllFiles = Utils.GetFilesAtPathRecursive(varFilePath + ":\\" + fileName, "*.dll", true);csFiles.UnionWith(orphanDllFiles);HashSet<string> orphanCsListFiles = Utils.GetFilesAtPathRecursive(varFilePath + ":\\" + fileName, "*.cslist", true);csListFiles.UnionWith(orphanCsListFiles);}}}if (csFiles.Count > 0 || csListFiles.Count > 0){VARPackageID varPackageID = new VARPackageID(varFilePath);if (varPackageID.varCreator == "AcidBubbles" && varPackageID.varPackageName == "Timeline" && csListFiles.Count == 0){string temp = "Custom/Scripts/AcidBubbles/Timeline/VamTimeline.AtomAnimation.cslist";if (FileManagerSecure.FileExists(varPackageID.varFileName + ":/" + temp)) csListFiles.Add(temp);temp = "Custom/Scripts/AcidBubbles/Timeline/VamTimeline.Controller.cslist";if (FileManagerSecure.FileExists(varPackageID.varFileName + ":/" + temp)) csListFiles.Add(temp);temp = "Custom/Scripts/VamTimeline.AtomAnimation.cslist";if (FileManagerSecure.FileExists(varPackageID.varFileName + ":/" + temp)) csListFiles.Add(temp);temp = "Custom/Scripts/VamTimeline.Controller.cslist";if (FileManagerSecure.FileExists(varPackageID.varFileName + ":/" + temp)) csListFiles.Add(temp);}if (varPackageID.varCreator == "AcidBubbles" && varPackageID.varPackageName == "ColliderEditor" && csListFiles.Count == 0){string temp = "Custom/Scripts/AcidBubbles/ColliderEditor/ColliderEditor.cslist";if (FileManagerSecure.FileExists(varPackageID.varFileName + ":/" + temp)) csListFiles.Add(temp);}if (varPackageID.varCreator == "geesp0t" && varPackageID.varPackageName == "EasyMoan" && csListFiles.Count == 0){string temp = "Custom/Scripts/geesp0t/EasyMoan/EasyMoan.cslist";if (FileManagerSecure.FileExists(varPackageID.varFileName + ":/" + temp)) csListFiles.Add(temp);}if (varPackageID.varCreator == "juniperD" && varPackageID.varPackageName == "Catalog3" && csFiles.Count > 0){string csFileRemove = "";foreach (string csf in csFiles) if (csf.StartsWith("Custom/Scripts/Catalog3/obj/Debug/.NET")) csFileRemove = csf;if (csFileRemove != "") csFiles.Remove(csFileRemove);}CreateManifestEntriesForCSFiles(csFiles, varPackageID);CreateManifestEntriesForCSFiles(csListFiles, varPackageID);}}catch (Exception){return;}}}private HashSet<string> creatorsSet = new HashSet<string>();private Dictionary<string, bool> creatorsPreferredDict = new Dictionary<string, bool>();private Dictionary<string, bool> creatorsConcealedDict = new Dictionary<string, bool>();private void AddCreatorToManifest(string creator){if (!creatorsSet.Contains(creator)){creatorsSet.Add(creator);if (!creatorsConcealedDict.ContainsKey(creator)) creatorsConcealedDict.Add(creator, false);if (!creatorsPreferredDict.ContainsKey(creator)) creatorsPreferredDict.Add(creator, false);}}private void CreateManifestEntriesForCSFiles(HashSet<string> csFiles, VARPackageID varPackageID){foreach (string csFile in csFiles){string pluginName = FileManagerSecure.GetFileName(csFile);string pluginPath = FileManagerSecure.GetDirectoryName(csFile, true);string pluginManifestEntryName = "LOCAL" + "." + pluginName;if (varPackageID != null) pluginManifestEntryName = varPackageID.varCreator + "." + varPackageID.varPackageName + "." + pluginName;if (pluginManinfestDict.ContainsKey(pluginManifestEntryName)){if (varPackageID != null) pluginManinfestDict[pluginManifestEntryName].AddVARVersion(varPackageID.varVersion, pluginPath);else pluginManinfestDict[pluginManifestEntryName].AddVARVersion(0, pluginPath);}else{if (varPackageID != null){PluginManifestEntry pme = new PluginManifestEntry(varPackageID.varCreator, pluginPath, csFile, pluginName, varPackageID.varPackageName, varPackageID.varVersion);pluginManinfestDict.Add(pluginManifestEntryName, pme);AddCreatorToManifest(varPackageID.varCreator);}else{PluginManifestEntry pme = new PluginManifestEntry(pluginPath, csFile, pluginName, false);pluginManinfestDict.Add(pluginManifestEntryName, pme);AddCreatorToManifest("LOCAL");}}}}}public class PluginManifestEntry{public string creator{get;private set;}public string varPackageName{get;private set;}public string pluginName{get;private set;}public string pluginPath{get;private set;}public bool isCSList{get;private set;}public int highestVARNumber{get;private set;}public bool isLocal{get;private set;}private Dictionary<int, bool> varVersionsCSListRef = new Dictionary<int, bool>();private Dictionary<int, HashSet<string>> varVersionsPathVariant = new Dictionary<int, HashSet<string>>();private Dictionary<string, bool> pathVariantConcealed = new Dictionary<string, bool>();private Dictionary<string, bool> pathVariantPreferred = new Dictionary<string, bool>();private HashSet<string> pathVariantsInSameVAR = new HashSet<string>();public HashSet<string> varVersionsNoCSListRef{get;private set;}public bool anyVariantsPreferred{get{foreach (KeyValuePair<string, bool> kvp in pathVariantPreferred){if (kvp.Value) return true;}return (false);}}public bool allVariantsConcealed{get{foreach (KeyValuePair<string, bool> kvp in pathVariantConcealed){if (!kvp.Value) return false;}return (true);}}public void SetVariantConcealed(string path, bool value, bool store = true){if (pathVariantConcealed.ContainsKey(path)){if (pathVariantsInSameVAR.Contains(path)) pathVariantConcealed[path] = value;else{foreach (string pvcKey in pathVariantConcealed.Keys.ToList()){if (!pathVariantsInSameVAR.Contains(path)) pathVariantConcealed[pvcKey] = value;}}}else Debug.Log("SetVariantConcealed: path variant '" + path + "' is not in plugin manifest");}public void SetAllVariantConcealedExcept(string path){HashSet<string> keys;if (pathVariantsInSameVAR.Contains(path)) keys = new HashSet<string>(pathVariantConcealed.Keys);else keys = new HashSet<string>(pathVariantsInSameVAR);foreach (string key in keys){if (key != path) SetVariantConcealed(key, true);}}public bool GetVariantConcelealed(string path){if (pathVariantConcealed.ContainsKey(path)) return (pathVariantConcealed[path]);else Debug.Log("GetVariantConcealed: path variant '" + path + "' is not in plugin manifest");return false;}public void SetVariantPreferred(string path, bool value, bool store = true){if (pathVariantPreferred.ContainsKey(path)){if (pathVariantsInSameVAR.Contains(path)) pathVariantPreferred[path] = value;else{foreach (string pvcKey in pathVariantPreferred.Keys.ToList()){if (!pathVariantsInSameVAR.Contains(path)) pathVariantPreferred[pvcKey] = value;}}}else{Debug.Log("SetVariantPreferred: path variant '" + path + "' is not in plugin manifest");}}public bool GetVariantPreferred(string path){if (pathVariantPreferred.ContainsKey(path)) return (pathVariantPreferred[path]);else Debug.Log("GetVariantPreferred: path variant '" + path + "' is not in plugin manifest");return false;}public string pluginNameNoFileExt{get{if (pluginName.EndsWith(".cs")) return pluginName.Substring(0, pluginName.Length - 3);if (pluginName.EndsWith(".dll")) return pluginName.Substring(0, pluginName.Length - 4);if (pluginName.EndsWith(".cslist")) return pluginName.Substring(0, pluginName.Length - 7);return (pluginName);}}public int varVersionCount{get{if (isLocal) return 0;return (varVersionsNoCSListRef.Count);}}public bool referencedByCSList{get{return (varVersionsCSListRef[highestVARNumber]);}}public string pluginManifestEntryName{get{if (isLocal) return (creator + "." + pluginName);return (creator + "." + varPackageName + "." + pluginName);}}public string pmeVariantFolderName{get{if (isLocal) return (creator + "." + pluginName);return (creator + "." + varPackageName + "." + pluginName);}}public PluginManifestEntry(string _creator,  string _path, string _fullpath, string _pluginName, string _varPackageName, int _varVersion, bool _csList = false){creator = _creator;pluginPath = _fullpath;isLocal = false;varPackageName = _varPackageName;CommonContructor(_pluginName, _csList);AddVARVersion(_varVersion, _path);}public PluginManifestEntry(string _path,string _fullpath, string _pluginName, bool _csList = false){pluginPath = _fullpath;creator = "LOCAL";isLocal = true;varPackageName = "";CommonContructor(_pluginName, _csList);AddVARVersion(0, _path);}private void CommonContructor(string _pluginName, bool _csList){varVersionsCSListRef = new Dictionary<int, bool>();varVersionsPathVariant = new Dictionary<int, HashSet<string>>();varVersionsNoCSListRef = new HashSet<string>();pathVariantConcealed = new Dictionary<string, bool>();pathVariantPreferred = new Dictionary<string, bool>();pathVariantsInSameVAR = new HashSet<string>();pluginName = _pluginName;isCSList = _csList;highestVARNumber = -1;}public int GetPathVariantCount(int varVersion){return (varVersionsPathVariant[varVersion].Count);}public int GetConcealedPathVariantCount(){return (pathVariantConcealed.Values.Where(p => p == true).Count());}public int GetPathVariantsInSameVARCount(){return (pathVariantsInSameVAR.Count());}public int GetPackageVersionsCount(){return (varVersionsNoCSListRef.Count);}public void AddVARVersion(int version, string path){if (!varVersionsCSListRef.ContainsKey(version)){varVersionsCSListRef.Add(version, false);varVersionsNoCSListRef.Add(version.ToString());}if (!varVersionsPathVariant.ContainsKey(version)){varVersionsPathVariant.Add(version, new HashSet<string>());varVersionsPathVariant[version].Add(path);}else if (!varVersionsPathVariant[version].Contains(path)) varVersionsPathVariant[version].Add(path);if (!pathVariantConcealed.ContainsKey(path)) pathVariantConcealed.Add(path, false);if (!pathVariantPreferred.ContainsKey(path)) pathVariantPreferred.Add(path, false);if (varVersionsPathVariant[version].Count == 2){foreach (string versionPath in varVersionsPathVariant[version]) pathVariantsInSameVAR.Add(versionPath);}else if (varVersionsPathVariant[version].Count > 2) pathVariantsInSameVAR.Add(path);if (version > highestVARNumber) highestVARNumber = version;}public void SetVARVersionReferencedInCSList(int version){if (varVersionsCSListRef.ContainsKey(version)){varVersionsCSListRef[version] = true;varVersionsNoCSListRef.Remove(version.ToString());}}public List<string> GetPluginsVersionsList(){List<int> intVerList = varVersionsCSListRef.Keys.ToList();intVerList.Sort();intVerList.Reverse();List<string> stringVerList = intVerList.ConvertAll(Convert.ToString);return (stringVerList);}}public class VARPackageID{public string varCreator{get;private set;}public string varPackageName{get;private set;}public int varVersion{get;private set;}public string varFileName{get;private set;}public VARPackageID(string varFilePath){string temp = FileManagerSecure.GetFileName(varFilePath);varFileName = temp.Substring(0, temp.Length - 4);varCreator = varFileName.Substring(0, varFileName.IndexOf('.'));temp = varFileName.Substring(varCreator.Length + 1);varPackageName = temp.Substring(0, temp.IndexOf('.'));temp = varFileName.Substring(varCreator.Length + varPackageName.Length + 2);varVersion = int.Parse(temp);}}}