/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using UnityEngine.UI;namespace PluginIdea.ContexMenuSystem{public class CustomTranslateData{public Vector3 pos;public Quaternion rot;}public class CallbackData{public string text;public OptBase opt;public ContextMenu subContex;public GameObject buttonObject;public bool isSplit = false;}public class CoreModule : CMModuleBase{private Transform navTrans;private CustomTranslateData tmpTranslateData = new CustomTranslateData();private Canvas popupCanvas;private CommandClass commandClass;private Dictionary<string, CallbackData> dic_callbacks = new Dictionary<string, CallbackData>();private GameObject buttonTemplate;private bool IsNavigationHologridEnable{set{if (SuperController.singleton.navigationHologrid != null){var rd = SuperController.singleton.navigationHologrid.GetComponentInChildren<Renderer>();if (rd) rd.enabled = value;}}}private float holdBeginTime;public CoreModule(ContexMenuSystem ower){this.ower = ower;}public override void Init(){Utils.SetupInfoText(ower, Location.GetStr(Location.PluginInfo), 500, true);navTrans = SuperController.singleton.navigationRig.transform;popupCanvas = Utils.AppendCanvasObjectUnderHeadCenter("ContexViewSpaceCanvas", true);ower.PopCanvas = popupCanvas;var canvasObj = popupCanvas.gameObject;ower.systemMenuAction += CreateSystemMenu;ower.sceneCommonMenuAction += CreateBaseSceneMenu;if (Utils.IsInVR()){EventBus.Instance.AddEventHandler(EventID.OnLeftNavgateUpEvent, OnLeftGrabNavgateUp);EventBus.Instance.AddEventHandler(EventID.OnSingleHandLeftUpEvent, OnSingleHandLeft);EventBus.Instance.AddEventHandler(EventID.OnRightNavgateUpEvent, OnRightGrabNavgateUp);EventBus.Instance.AddEventHandler(EventID.OnSingleHandRightUpEvent, OnSingleHandRight);IsNavigationHologridEnable = false;}EventBus.Instance.AddEventHandler<float>(EventID.OnUIScaleChangedEvent, OnUIScaleChanged);}public override void OnReApplyUIParameter(){commandClass = new CommandClass(ower.ContexMenuUIObject, popupCanvas.transform);}private void OnUIScaleChanged(float scale){GlobalSetting.uiscale = scale;SuperController.singleton.monitorUIScale = scale;if (popupCanvas != null) popupCanvas.scaleFactor = scale;}private Vector3 beginMousePos;public override void OnUpdate(){if (!Utils.IsInVR() && GlobalSetting.isUseLMBClick){if (Input.GetMouseButtonDown(1)){holdBeginTime = Time.realtimeSinceStartup;beginMousePos = Input.mousePosition;}float rbmHoldTime = Time.realtimeSinceStartup - holdBeginTime;if (rbmHoldTime == 0) return;if (Input.GetMouseButtonUp(1) && rbmHoldTime < GlobalSetting.mouseHoldTimeTriggerSensitivity){float disDelta = Vector3.Distance(Input.mousePosition, beginMousePos);if (disDelta < GlobalSetting.mouseMoveTriggerSenserty){if (Input.GetKey(KeyCode.LeftAlt)){CreateSystemMenu();}else{CreateSceneMenu();}}}}}private bool leftGrabNavgateBeginHold, rightGrabNavgateBeginHold;private float leftNavHoldTime, rightNavHoldTime;private void OnLeftGrabNavgateUp(){SetPopCanvas();if (GlobalSetting.currentOptMode == OperationMode.DoubleHandle){CreateSystemMenu();}else{CreateSceneMenu();}}private void OnSingleHandLeft(){if (GlobalSetting.currentOptMode != OperationMode.DoubleHandle){CreateSystemMenu();}}private void OnRightGrabNavgateUp(){SetPopCanvas();CreateSceneMenu();}private void OnSingleHandRight(){if (GlobalSetting.currentOptMode != OperationMode.DoubleHandle){CreateSystemMenu();}}private void SetPopCanvas(){Transform ctrans = SuperController.singleton.centerCameraTarget.transform;Vector3 pos = ctrans.position + ctrans.forward * GlobalSetting.menuDistance - ctrans.up * 0.15f- ctrans.right * 0.05f;var rt = popupCanvas.GetComponent<RectTransform>();rt.position = pos;rt.LookAt(pos + ctrans.forward);}private void CreateSceneMenu(){if (GlobalSetting.currentMenuType == MenuType.SceneCommonMenu){CreateBaseSceneMenu();}}private void CreateSystemMenu(){bool isVR = Utils.IsInVR();commandClass.CreateMenuTree(new CheckInfo(){type = CommandType.CommonMenu, hit = ower.RaycastHit});SuperController.singleton.StartCoroutine(Utils.WaitTimeCall(.1f, () =>{if (!isVR){commandClass.ShowAtMousePosition(MenuType.SystemMenu);}else{commandClass.ShowInVR(MenuType.SystemMenu);}}));}private int lastSceneTimerID;private void CreateBaseSceneMenu(){bool isHitObject = ower.GetRaycastObject();Debug.Log(isHitObject);bool isUICast = ower.GetUIRaycastList();if (!isUICast && !isHitObject) return;CheckInfo checkInfo;if (CommandCheck.CheckRightClick(ower.RaycastHit, ower.CastList, out checkInfo)){commandClass.CreateMenuTree(checkInfo);SuperController.singleton.StartCoroutine(Utils.WaitTimeCall(.1f, () =>{if (!Utils.IsInVR()){commandClass.ShowAtMousePosition(MenuType.SceneCommonMenu);}else{commandClass.ShowInVR(MenuType.SceneCommonMenu);}}));}}public override void UnInit(){if (popupCanvas != null){dic_callbacks.Clear();GameObject.Destroy(popupCanvas.gameObject);commandClass.UnInit();}ower.systemMenuAction -= CreateSystemMenu;ower.sceneCommonMenuAction -= CreateBaseSceneMenu;if (Utils.IsInVR()){EventBus.Instance.RemoveEventHandler(EventID.OnLeftNavgateUpEvent, OnLeftGrabNavgateUp);EventBus.Instance.RemoveEventHandler(EventID.OnSingleHandLeftUpEvent, OnSingleHandLeft);EventBus.Instance.RemoveEventHandler(EventID.OnRightNavgateUpEvent, OnRightGrabNavgateUp);EventBus.Instance.RemoveEventHandler(EventID.OnSingleHandRightUpEvent, OnSingleHandRight);EventBus.Instance.RemoveEventHandler<float>(EventID.OnUIScaleChangedEvent, OnUIScaleChanged);IsNavigationHologridEnable = true;}}}}