/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using System;using UnityEngine.EventSystems;using UnityEngine.UI;using UnityEngine.Events;using SimpleJSON;using MVR.FileManagementSecure;using MeshVR;namespace PluginIdea.ContexMenuSystem{public class VAMEventModule : CMModuleBase{public struct SpectionActState{public const int None = 0;public const int Duplicate = 1;public const int CopyPaste = 2;}public static Atom lastAtom;public static int currentSpectionActState = 0;public VAMEventModule(ContexMenuSystem ower){this.ower = ower;SuperController.singleton.onAtomAddedHandlers += OnAtomAdded;SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;}private void OnSceneLoaded(){}private void OnAtomAdded(Atom atom){if (currentSpectionActState == SpectionActState.Duplicate){if (lastAtom != null){if (atom.type == lastAtom.type){SyncPropertiesWithAtom(lastAtom, atom);}currentSpectionActState = SpectionActState.None;}}else if (currentSpectionActState == SpectionActState.CopyPaste){string type = PropetyCopyOpt.recordinfo.atominfo.type;if (string.IsNullOrEmpty(type)) return;if (atom.type == type){SyncPropertiesWithDic(PropetyCopyOpt.recordinfo.atominfo, atom);currentSpectionActState = SpectionActState.None;}}}private void SyncPropertiesWithDic(PropetyCopyOpt.AtomInfo atomInfo, Atom to){Dictionary<string, JSONClass> dic_jc = atomInfo.dic_uid2jc;if (dic_jc.Count == 0) return;if (dic_jc.ContainsKey("PluginManager")){var managerJS = dic_jc["PluginManager"];JSONClass currentPluginsJS = (JSONClass)managerJS["plugins"];if (currentPluginsJS != null){foreach (KeyValuePair<string, JSONNode> kvp in currentPluginsJS){string pluginEntry = currentPluginsJS[kvp.Key];if (string.IsNullOrEmpty(pluginEntry)) continue;LoadPluginsAsPreset(to, pluginEntry);}}}dic_jc.Keys.ToList().ForEach(id =>{JSONClass jc = dic_jc[id];if (id == "Trigger"){Transform rscale = to.reParentObject.Find("object/rescaleObject");var triggerHander = rscale.GetComponentInChildren<JSONStorableTriggerHandler>();if (triggerHander != null){if (triggerHander is UIButtonTrigger){var buttonTrigger = triggerHander as UIButtonTrigger;buttonTrigger.trigger.RestoreFromJSON(jc["trigger"] as JSONClass);}else if (triggerHander is UISliderTrigger){var sliderTrigger = triggerHander as UISliderTrigger;sliderTrigger.trigger.RestoreFromJSON(jc["trigger"] as JSONClass);}else if (triggerHander is UIToggleTrigger){var toggleTrigger = triggerHander as UIToggleTrigger;toggleTrigger.trigger.RestoreFromJSON(jc["trigger"] as JSONClass);}}}else{to.GetStorableByID(id).RestoreFromJSON(jc);}});}private void SyncPropertiesWithAtom(Atom source, Atom to){to.parentAtom = source.parentAtom;var manager = source.GetStorableByID("PluginManager") as MVRPluginManager;if (manager != null){JSONClass managerJS = manager.GetJSON(true, true, true);JSONClass currentPluginsJS = (JSONClass)managerJS["plugins"];if (currentPluginsJS != null){foreach (KeyValuePair<string, JSONNode> kvp in currentPluginsJS){string pluginEntry = currentPluginsJS[kvp.Key];if (string.IsNullOrEmpty(pluginEntry)) continue;LoadPluginsAsPreset(to, pluginEntry);}}}var ids = source.GetStorableIDs();ids.ForEach(id =>{var st = source.GetStorableByID(id);JSONClass jc = st.GetJSON();if (id == "Trigger"){Transform rscale = to.reParentObject.Find("object/rescaleObject");var triggerHander = rscale.GetComponentInChildren<JSONStorableTriggerHandler>();if (triggerHander != null){if (triggerHander is UIButtonTrigger){var buttonTrigger = triggerHander as UIButtonTrigger;buttonTrigger.trigger.RestoreFromJSON(jc["trigger"] as JSONClass);}else if (triggerHander is UISliderTrigger){var sliderTrigger = triggerHander as UISliderTrigger;sliderTrigger.trigger.RestoreFromJSON(jc["trigger"] as JSONClass);}else if (triggerHander is UIToggleTrigger){var toggleTrigger = triggerHander as UIToggleTrigger;toggleTrigger.trigger.RestoreFromJSON(jc["trigger"] as JSONClass);}}}to.GetStorableByID(id).RestoreFromJSON(jc);});if (to.type != "Person"){Bounds bounds;if (Utils.GetAtomBounds(source, out bounds)){to.mainController.transform.position = source.mainController.transform.position + source.mainController.transform.right * (bounds.extents.x + 0.5f);}}}private void LoadPluginsAsPreset(Atom atom, string pluginPath){var manager = atom.GetStorableByID("PluginManager") as MVRPluginManager;JSONClass pluginMgrJC = manager.GetJSON(true, true, true);JSONClass pluginsJC = pluginMgrJC["plugins"].AsObject;pluginsJC.Childs.ToList().ForEach(xx =>{SuperController.LogMessage(xx.ToString());});int nextFreeSlot = pluginsJC.Count;JSONClass pluginPresetJSON = new JSONClass();pluginPresetJSON["setUnlistedParamsToDefault"].AsBool = true;JSONArray pluginPresetStorablesJSON = new JSONArray();pluginPresetJSON["storables"] = pluginPresetStorablesJSON;JSONClass pluginMgrStorableJSON = new JSONClass();pluginPresetStorablesJSON.Add(pluginMgrStorableJSON);pluginMgrStorableJSON["id"] = "PluginManager";JSONClass pluginMgrPluginsListJSON = new JSONClass();pluginMgrStorableJSON["plugins"] = pluginMgrPluginsListJSON;string normalFilePath = SuperController.singleton.NormalizePath(pluginPath);Debug.Log(normalFilePath);if (FileManagerSecure.FileExists(pluginPath)){pluginMgrPluginsListJSON["plugin#0"] = normalFilePath;}PresetManager pm;if (atom.name == "CoreControl"){if (atom.type == "SessionPluginManager") pm = atom.GetComponentInChildren<PresetManager>();else{JSONStorable js = atom.GetStorableByID("PluginManagerPresets");pm = js.GetComponentInChildren<PresetManager>();}}else{if (atom.type != "Person") pm = atom.GetComponentInChildren<PresetManager>();else{JSONStorable js = atom.GetStorableByID("PluginPresets");pm = js.GetComponentInChildren<PresetManager>();}}atom.SetLastRestoredData(pluginPresetJSON, true, true);pm.LoadPresetFromJSON(pluginPresetJSON, true);}public override void Init(){}public override void OnReApplyUIParameter(){}public override void OnUpdate(){}public override void UnInit(){SuperController.singleton.onAtomAddedHandlers -= OnAtomAdded;SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;}}}