/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using System;using UnityEngine.EventSystems;using UnityEngine.UI;using UnityEngine.Events;using System.Linq;namespace PluginIdea.ContexMenuSystem{public class VisualizeModule : CMModuleBase{private List<string> markTypeStrings = new List<string>{"MarkBall", "SurroundingBox"};private string[] ingoreIDs = new string[]{"WindowCamera"};private List<Renderer> effectiveMrs = new List<Renderer>();private Atom lastSelectedAtom;private FreeControllerV3 lastFv3;private bool isOnDraw;private Bounds lastBounds;private JSONStorableBool wireInActive;private JSONStorableBool textTipActive;private JSONStorableBool markActive;private JSONStorableColor wireColor;private JSONStorableFloat wireAlpha;private JSONStorableStringChooser markType;private JSONStorableFloat markBallRadius;private JSONStorableFloat tipBgAlpha;private int lastDrawID = -1;private GameObject controllerSphere;public VisualizeModule(ContexMenuSystem ower){this.ower = ower;controllerSphere = GameObject.CreatePrimitive(PrimitiveType.Sphere);controllerSphere.transform.localScale = Vector3.one * 0.1f;controllerSphere.GetComponent<Collider>().enabled = false;controllerSphere.name = "MarkBall";controllerSphere.SetActive(false);}public override void Init(){if (!Utils.IsInVR()){Utils.SetupInfoTextNoScroll(this.ower, Location.GetStr(Location.TipTextSubtitle), 35, false);textTipActive = Utils.SetupToggle(ower, Location.GetStr(Location.ActiveTip), true, false, ower.isPaidVersion);textTipActive.setCallbackFunction = (val) =>{GlobalSetting.showTip = val;};tipBgAlpha = Utils.SetupSliderFloat(ower, Location.GetStr(Location.TipBgAlpha), 0.3f, 0f, 1f, false, ower.isPaidVersion);tipBgAlpha.setCallbackFunction = (val) =>{Image image = ower.TipTrans.GetComponent<Image>();image.color = new Color(image.color.r, image.color.g, image.color.b, val);};}Utils.SetupInfoTextNoScroll(this.ower, Location.GetStr(Location.VisulizeSubtitle), 35, false);markActive = Utils.SetupToggle(ower, Location.GetStr(Location.MarkActive), true, false, true);markActive.setCallbackFunction = (val) =>{GlobalSetting.showMark = val;};markType = Utils.SetupStringChooser(ower, Location.GetStr(Location.MarkType), markTypeStrings, false, true);markType.setCallbackFunction = (val) =>{GlobalSetting.currentMarkMode = markTypeStrings.IndexOf(val);if (GlobalSetting.currentMarkMode == HitMarkMode.BoundBox) controllerSphere.SetActive(false);};markBallRadius = Utils.SetupSliderFloat(ower, Location.GetStr(Location.MarkBallRadius), 0.04f, 0.01f, 0.2f, false, true);markBallRadius.setCallbackFunction = (val) =>{if (controllerSphere != null) controllerSphere.transform.localScale = Vector3.one * val;};wireInActive = Utils.SetupToggle(ower, Location.GetStr(Location.IsShowInactiveBounds), false, false, true);wireInActive.setCallbackFunction = (val) =>{GlobalSetting.isBoundInActive = val;};wireColor = Utils.SetupColor(ower, Location.GetStr(Location.OutlineColor), Color.yellow, false);wireColor.setCallbackFunction = (h, s, v) =>{GlobalSetting.wireColor = Color.HSVToRGB(h, s, v);if (controllerSphere != null) controllerSphere.GetComponent<Renderer>().material.color = GlobalSetting.wireColor;};wireAlpha = Utils.SetupSliderFloat(ower, Location.GetStr(Location.MarkBallAlpha), 0.5f, 0f, 1f, false, true);wireAlpha.setCallbackFunction = (val) =>{if (controllerSphere){Material material = controllerSphere.GetComponent<Renderer>().material;material.color = new Color(material.color.r, material.color.g, material.color.b, val);}};}public override void OnReApplyUIParameter(){Material material = controllerSphere.GetComponent<Renderer>().material;material.shader = ower.Dic_name2Shader["PluginIdea/SimpleColor"];material.color = GlobalSetting.wireColor;markActive.setCallbackFunction(markActive.val);wireInActive.setCallbackFunction(wireInActive.val);wireColor.setCallbackFunction(wireColor.val.H,wireColor.val.S,wireColor.val.V);wireAlpha.setCallbackFunction(wireAlpha.val);markType.setCallbackFunction(markType.val);markBallRadius.setCallbackFunction(markBallRadius.val);if (!Utils.IsInVR()){tipBgAlpha.setCallbackFunction(tipBgAlpha.val);textTipActive.setCallbackFunction(textTipActive.val);}}public override void OnUpdate(){if (GlobalSetting.showOutLine){if (!EventSystem.current.IsPointerOverGameObject() && ower.IsCastObject()){var hit = ower.RaycastHit;if (hit.collider == null) return;Atom atom = hit.collider.GetComponentInParent<Atom>();if (atom.type == "SubScene"){atom = hit.collider.transform.parent.GetComponentInChildren<SetTransformScale>()?.containingAtom;}if (atom == null) return;ower.TipLabel.text = atom.uid;if (GlobalSetting.currentMarkMode == HitMarkMode.BoundBox){if (lastSelectedAtom != atom){if (lastSelectedAtom != null)                                lastSelectedAtom = atom;atom.reParentObject.GetComponentsInChildren<Renderer>(GlobalSetting.isBoundInActive, effectiveMrs);}isOnDraw = CanShowOutLine() && atom.type != "Person" && !ingoreIDs.Contains(atom.type);}else if (GlobalSetting.currentMarkMode == HitMarkMode.ControllerSphere){FreeControllerV3 fv3 = hit.collider.GetComponent<FreeControllerV3>();if (fv3 != null && atom.type != "Person"){isOnDraw = true;controllerSphere.transform.position = fv3.transform.position;}else{if (atom != null){isOnDraw = true;controllerSphere.transform.position = atom.mainController.transform.position;}else{isOnDraw = false;}}isOnDraw &= !ingoreIDs.Contains(atom.type);controllerSphere?.SetActive(isOnDraw && GlobalSetting.showMark);SyncTipTexPosition(controllerSphere.transform.position);}}else{isOnDraw = false;controllerSphere?.SetActive(isOnDraw);effectiveMrs.Clear();}}else{isOnDraw = false;effectiveMrs.Clear();}ower.TipTrans.gameObject.SetActive(isOnDraw && GlobalSetting.showTip);}private void SyncTipTexPosition(Vector3 worldPos){Vector3 sc = Utils.CenterCamera.WorldToScreenPoint(worldPos);ower.TipTrans.position = sc;}private bool CanShowOutLine(){return !IsInBound() && GlobalSetting.showMark;}Bounds b;private bool IsInBound(){if (effectiveMrs.Count > 0){Vector3 sum = Vector3.zero;Vector3 center = Vector3.zero;for (int i = 0;i < effectiveMrs.Count;i++){if (effectiveMrs[i] == null) continue;sum += effectiveMrs[i].bounds.center;}center = sum / effectiveMrs.Count;b = new Bounds(center, Vector3.zero);for (int i = 0;i < effectiveMrs.Count;i++){if (effectiveMrs[i] == null) continue;b.Encapsulate(effectiveMrs[i].bounds);}Vector3 triggerPos = Vector3.zero;if (Utils.IsInVR()){if (GlobalSetting.currentOptMode == OperationMode.DoubleHandle || GlobalSetting.currentOptMode == OperationMode.SingleHandleRight){triggerPos = ower.RightHandTrans.position;}else{triggerPos = ower.LeftHandTrans.position;}}else{triggerPos = Utils.CenterCameraTrans.position;}bool isContain = b.Contains(triggerPos);return isContain;}return false;}private bool isEnterDraw = false;public override void OnPostRender(){if (GlobalSetting.currentMarkMode == HitMarkMode.BoundBox){if (Utils.IsInVR()){if (isOnDraw){if (b.center != lastBounds.center && b.extents != lastBounds.extents){isEnterDraw = false;GizmosHelper.RemoveLineRendererGizmos(lastDrawID);}if (!isEnterDraw){isEnterDraw = true;lastDrawID = GizmosHelper.DrawBoundsLineRenderer(b, Color.HSVToRGB(wireColor.val.H, wireColor.val.S, wireColor.val.V));lastBounds = b;}}else{if (isEnterDraw){isEnterDraw = false;GizmosHelper.RemoveLineRendererGizmos(lastDrawID);}}}else{if (isOnDraw)                        GizmosHelper.DrawBounds(b, Color.HSVToRGB(wireColor.val.H, wireColor.val.S, wireColor.val.V));}SyncTipTexPosition(b.center);}}public override void UnInit(){isOnDraw = false;GameObject.Destroy(controllerSphere);}}}